<?php
/************************************************************************/
/* PHP-NUKE Recipe Module                                               */
/* ===========================                                          */
/*                                                                      */
/* Copyright (c) 2003 by Sean Pluard http://heartstorm.org (ver 1.4.1)  */
/* Copyright (c) 2003 by Jens Hauge  http://visayas.dk (ver 1.5.x)      */
/* Support site http://phpnuke.visayas.dk                               */
/*                                                                      */
/* This program is free software. You can redistribute it and/or modify */
/* it under the terms of the GNU General Public License as published by */
/* the Free Software Foundation.                                        */
/************************************************************************/
$module_name = basename(dirname(__FILE__));

if (!eregi("modules.php", $_SERVER['PHP_SELF'])) {
    die ("You can't access this file directly...");
}

require_once("mainfile.php");

include("modules/$module_name/general_functions.php.inc");
$index = 1;
get_lang($module_name);
define("GIS_GIF",     1);
define("GIS_JPG",     2);
define("GIS_PNG",     3);

function make_clickable($text)
{
	$ret = " " . $text;
	$ret = preg_replace("#([\n ])([a-z]+?)://([a-z0-9\-\.,\?!%\*_\#:;~\\&$@\/=\+]+)#i", "\\1<a href=\"\\2://\\3\" target=\"_blank\">\\2://\\3</a>", $ret);
	$ret = preg_replace("#([\n ])www\.([a-z0-9\-]+)\.([a-z0-9\-.\~]+)((?:/[a-z0-9\-\.,\?!%\*_\#:;~\\&$@\/=\+]*)?)#i", "\\1<a href=\"http://www.\\2.\\3\\4\" target=\"_blank\">www.\\2.\\3\\4</a>", $ret);
	$ret = preg_replace("#([\n ])([a-z0-9\-_.]+?)@([\w\-]+\.([\w\-\.]+\.)?[\w]+)#i", "\\1<a href=\"mailto:\\2@\\3\">\\2@\\3</a>", $ret);
	$ret = substr($ret, 1);

	return($ret);
}

function reseize_image($src_file, $dest_file)
{
	global $ERROR;

	$imginfo = getimagesize($src_file);
	if ($imginfo == null)
		return false;

	// GD can only handle JPG & PNG images
	if ($imginfo[2] != GIS_JPG && $imginfo[2] != GIS_PNG && ($_SESSION["method"] == 'gd1' || $_SESSION["method"] == 'gd2')){
		$ERROR = ""._GD_FILE_TYPE_ERR;
		return false;
	}

	// height/width
	$srcWidth = $imginfo[0];
	$srcHeight = $imginfo[1];
	$srcFilesize = filesize($src_file);
    
	if ($_SESSION["fittype"]=="pic_size") {
		$ratio = max($srcWidth, $srcHeight) / $_SESSION["pic_size"];
	} else {
		$ratio = $srcFilesize/$_SESSION["maxsizeforphotos"];
	}
	$ratio = max($ratio, 1.0);
	$destWidth = (int)($srcWidth / $ratio);
	$destHeight = (int)($srcHeight / $ratio);
	// Method for creation of new file
	switch ($_SESSION["method"]) {
	case "im" :
		if (preg_match("#[A-Z]:|\\\\#Ai",__FILE__)){
			// get the basedir, remove '/include'
			$cur_dir = "";
			$src_file =   '"'.strtr($src_file, '/', '\\').'"';
			$im_dest_file = str_replace('%', '%%', ('"'.strtr($dest_file, '/', '\\').'"'));
		} else {
			$src_file =   escapeshellarg($src_file);
			$im_dest_file = str_replace('%', '%%', escapeshellarg($dest_file));
		}

		$output = array();
		$cmd = "{$_SESSION["impath"]}convert -quality {$_SESSION["jpeg_qual"]} {$_SESSION["im_options"]} -geometry {$destWidth}x{$destHeight} $src_file $im_dest_file";
		exec ($cmd, $output, $retval);

		if ($retval) {
		    $ERROR = ""._IM_ERROR." $retval";
			@unlink($dest_file);
			return false;
		}
		break;

	case "gd1" :
		if (!function_exists('imagecreatefromjpeg')) {
 		    die("PHP running on your server does not support the GD image library, check with your webhost if ImageMagick is installed");
		}

		if ($imginfo[2] == GIS_JPG)
			$src_img = imagecreatefromjpeg($src_file);
		else
			$src_img = imagecreatefrompng($src_file);
		if (!$src_img){
			$ERROR = ""._INVALID_IMAGE;
			return false;
		}
		$dst_img = imagecreate($destWidth, $destHeight);
		imagecopyresized($dst_img, $src_img, 0, 0, 0, 0, $destWidth, $destHeight, $srcWidth, $srcHeight);
		imagejpeg($dst_img, $dest_file, $_SESSION["jpeg_qual"]);
		imagedestroy($src_img);
		imagedestroy($dst_img);
		break;

	case "gd2" :
	if (!function_exists('imagecreatefromjpeg')) {
 		    die("PHP running on your server does not support the GD image library, check with your webhost if ImageMagick is installed");
 		}
 		if (!function_exists('imagecreatetruecolor')) {
 		    die("PHP running on your server does not support GD version 2.x, please switch to GD version 1.x on the config page");
 		}

		if ($imginfo[2] == GIS_JPG)
			$src_img = imagecreatefromjpeg($src_file);
		else
			$src_img = imagecreatefrompng($src_file);
		if (!$src_img){
			$ERROR = ""._INVALID_IMAGE;
			return false;
		}
		$dst_img = imagecreatetruecolor($destWidth, $destHeight);
		imagecopyresampled($dst_img, $src_img, 0, 0, 0, 0, $destWidth, (int)$destHeight, $srcWidth, $srcHeight);
		imagejpeg($dst_img, $dest_file, $_SESSION["jpeg_qual"]);
		imagedestroy($src_img);
		imagedestroy($dst_img);
		break;
	}


	// Set mode of uploaded picture
	chmod($dest_file, octdec($_SESSION["default_file_mode"]));

	// We check that the image is valid
	$imginfo = getimagesize($dest_file);
	if ($imginfo == null){
		$ERROR = ""._RESIZEERR;
		@unlink($dest_file);
		return false;
	} else {
		return true;
	}
}


function list_recipes ($qdb, $qdborder, $limit) {
	GLOBAL $db, $module_name, $pagenum, $query, $op;
	if ($pagenum == "") { $pagenum = 1 ; }
	$offset = ($pagenum-1) * $_SESSION["recipnum"] ;
	$sql = "select R.id, recipename, cat_id, contributer, photo, counter,S.score/S.number_votes as rate from ".$_SESSION["recipeprefix"]."_recipes R LEFT JOIN ".$_SESSION["recipeprefix"]."_score S ON(R.id=S.id) $qdb $qdborder limit $offset, $limit";
	list_recipes_dis ($qdb, $qdborder, $limit,$sql);
}

function list_recipes_dis ($qdb, $qdborder, $limit,$sql) {
	GLOBAL $db, $module_name, $pagenum, $query, $op;
	if ($pagenum == "") { $pagenum = 1 ; }
	$offset = ($pagenum-1) * $_SESSION["recipnum"];
	$result = $db->sql_query($sql);
//echo "<br> sql $sql";
	if ($db->sql_numrows($result) == 0) {
		if ($op=="alphabrowse"){
			echo "<br><center><b>"._NORECIPESFOUNDSTARTING." '$query'.</b><br></center>";
		} else {
			echo "<br><center><b>"._NORECIPESFOUNDSEARCH.".</b><br>"._GOBACK."<br></center>";
		}
	}	
	else {
		$sql_pn = "select id from ".$_SESSION["recipeprefix"]."_recipes $qdb limit ".$_SESSION["limitpn"];
		$result_pn = $db->sql_query($sql_pn);
		$numrecip = $db->sql_numrows($result_pn);
		$_SESSION["numrecip"] = $numrecip;
		$_SESSION["qdb"] = $qdb;
		$_SESSION["qdborder"] = $qdborder;
		
		echo "<center><table border=0 width=\"100%\"><font class=\"content\">";
		if ($_SESSION["photoicon"]) {
			echo "<th>"._PHOTO."</th>";
		}
		echo "<th align=\"left\">"._RECIPENAME."</th>
			<th align=\"left\">"._COUNT."</th>
			<th align=\"left\">"._RATING."</th>
			<th align=\"left\">"._CATEGORY."</th>
			<th align=\"left\">"._SUBMITTER."</th>";
		while ($row = $db->sql_fetchrow($result)) {
			if ($_SESSION["photoicon"]) {
				if ($row[photo]=="") {
					echo "<tr><td class=\"row1\">&nbsp</td>";
				} else {
					echo "<tr><td class=\"row1\" width=\"10\"><img src=\"modules/$module_name/images/Photo.jpg\" border=\"0\"></td>";
				}
			} else {
				echo "<tr>";
			}
			$rate = $row[rate];
			if (isset($rate)) {
		    	$r_image = round($rate);
 				$the_image = "<img src=\"modules/$module_name/images/stars-$r_image.gif\" border=\"0\">";
			} else {
		    	$the_image = "";
			}
			
			echo "<td class=\"row1\"><a href=\"modules.php?name=$module_name&amp;op=viewrecipe&amp;recipeid=$row[id]&amp;offset=$offset\">$row[recipename]</a> </td>
			<td class=\"row1\">$row[counter]</td>
			<td nowrap=\"nowrap\" class=\"row1\">$the_image&nbsp;$row[rate]</td>
			<td class=\"row1\">".getCategory($row[cat_id])."</td>
			<td class=\"row1\"> <cite>$row[contributer]</cite></td></tr>";
			$offset = $offset+1;
			}
		echo "</font></table><br>";
		
		$numpages = ceil($numrecip / $_SESSION["recipnum"]);
		#if ($numpages > 1 ) {
		if (($numpages > 1) && ($limit>=$_SESSION["recipnum"])) {
			opentable();
			echo "<center>$numrecip "._RECIPES." ($numpages "._PAGES.", ".$_SESSION["recipnum"]." "._PERPAGE.")<br>" ;
			if ($pagenum > 1) {
				$prevpage = $pagenum - 1 ;
				$leftarrow = "images/left.gif" ;
				echo "<a href=\"modules.php?name=$module_name&amp;op=newpage&amp;pagenum=$prevpage\">";
				echo "<img src=\"$leftarrow\" align=\"absmiddle\" border=\"0\" hspace=\"10\"></a>";
			}
			echo "[ " ;
			for ($i=1; $i < $numpages+1; $i++) {
				if ($i == $pagenum) {
					echo "<b>$i</b>";
				} else {
					echo "<a href=\"modules.php?name=$module_name&amp;op=newpage&amp;pagenum=$i\">$i</a>";
				}
				if ($i < $numpages) { echo " | "; } else { echo " ]"; }
			}
			if ($pagenum < $numpages) {
				$nextpage = $pagenum + 1 ;
				$rightarrow = "images/right.gif" ;
				echo "<a href=\"modules.php?name=$module_name&amp;op=newpage&amp;pagenum=$nextpage\">";
				echo "<img src=\"$rightarrow\" align=\"absmiddle\" border=\"0\" hspace=\"10\"></a>";
			}
			echo "</center>" ;
			closetable();
		}
	}
}


function issetup() {
	global $db;
		$q = "SELECT * FROM ".$_SESSION["recipeprefix"]."_recipes LIMIT 1";
		$result = $db->sql_query($q);
		return $result;
}


function searchStart() {
	Global $module_name, $db;
	echo "<center><form method=post action=\"modules.php?name=$module_name\"><input name=op type=hidden value=search>";
	echo "<table border=0 width=100%><center><th colspan=\"4\">"._SEARCHQUERY."</th></center>";
	echo "<tr><font class=\"content\"><td class=\"row1\" colspan=\"2\" width=\"50%\"><span class=\"explaintitle\" >"._SEARCHFOR."</span></td></font><td class=\"row1\" colspan=\"2\"><input name=searchtext style=\"width: 300px\" class=\"post\"></td></tr>";
	echo "<tr><font class=\"content\"><td class=\"row1\" colspan=\"2\" width=\"50%\"><span class=\"explaintitle\" >"._SEARCHFORSUBMITTER."</span></td></font><td class=\"row1\" colspan=\"2\"><input name=searchsubmitter style=\"width: 300px\" class=\"post\" ></td></tr>";
	echo "<center><th colspan=\"4\">"._SEARCHOPTIONS."</th></center>";

	echo "<tr><td class=\"row1\" align=\"right\"><span class=\"explaintitle\">"._SEARCHPHOTO."</span></td>";
	echo "<td class=\"row2\" colspan=\"3\"><input type=\"checkbox\" name=\"chphoto\" value=\"X\" >"._ONLYWITHPHOTO."</td>";

	echo "<tr><td class=\"row1\" align=\"right\"><span class=\"explaintitle\">"._SEARCHIN."</span></td>";
	echo "<td class=\"row2\" colspan=\"3\"><table width=\"100%\" border=\"0\" cellspacing=\"0\" cellpadding=\"0\">";
	echo "<td><input type=\"checkbox\" name=\"chall\" value=\"X\" checked=\"checked\">"._ALL."</td>";
	echo "<td><input type=\"checkbox\" name=\"chname\" value=\"X\">"._RECIPENAME."</td>";
	echo "<td><input type=\"checkbox\" name=\"chintroduction\" value=\"X\">"._INTRODUCTION."</td>";
	echo "</tr><tr>";
	echo "<td><input type=\"checkbox\" name=\"chingredients\" value=\"X\">"._INGREDIENTS."</td>";
	echo "<td><input type=\"checkbox\" name=\"chdirections\" value=\"X\">"._DIRECTIONS."</td>";
	echo "<td><input type=\"checkbox\" name=\"chnutrition\" value=\"X\">"._NUTRITION."</td>";
	echo "</tr></table></td>";
	$sql="select * from ".$_SESSION["recipeprefix"]."_categories order by category";
	$result = $db->sql_query($sql);
	echo "<tr><td class=\"row1\" align=\"right\"><span class=\"explaintitle\">"._CATEGORY."</span></td><td class=\"row2\"><select name=cat_id>";
	echo "<option value=-1 selected>"._RCALLCATEGORIES."";
	while ($row = $db->sql_fetchrow($result)) {
		echo "<option value='$row[id]'>$row[category]";
	};
	echo "</select></td>";
	echo "<td class=\"row1\" align=\"right\"><span class=\"explaintitle\">"._ORDERBY."</td>";
	echo "<td class=\"row2\"><table width=\"100%\" border=\"0\" cellspacing=\"0\" cellpadding=\"0\"><tr>";
	echo "<td class=\"row1\" ><select name=sort><option value=recipename selected>"._RECIPENAME."";
	echo "<option value=category>"._CATEGORY."";
	echo "<option value=submittime>"._SUBMITTIME."";
	echo "<option value=counter>"._COUNT."";
	echo "<option value=rate>"._SCORE."";
	echo "</select></td></tr>";
	echo "<tr>";
	echo "<table width=\"100%\" border=\"0\" cellspacing=\"0\" cellpadding=\"0\"><td class=\"row2\">";
	echo "<input type=\"radio\" name=\"sort_dir\" value=\"ASC\" checked=\"checked\"/></td><td nowrap=\"nowrap\" class=\"row2\" align=\"left\">&nbsp;"._ASCENDING."</td></tr>";
	echo "<tr>";
	echo "<td class=\"row2\"><input type=\"radio\" name=\"sort_dir\" value=\"DESC\" /></td><td nowrap=\"nowrap\" class=\"row2\" align=\"left\">&nbsp;"._DESCENDING."</td></tr>";
	echo "</table>";
	echo "</table>";
	echo "<br><input name=submit type=submit value=\""._SEARCH."\"></form>";
}


function getFile($userfile) {
	Global $module_name, $ERROR;
	$path = "modules/$module_name/photos/";
	$fname=uniqid("");
	$fname=$fname.".jpg";
	$dest = $path."".$fname;
	if (is_uploaded_file($userfile['tmp_name'])) {

		if ($_SESSION["autoresize"]){
	
			if (!reseize_image($userfile['tmp_name'],$dest)) {
				move_uploaded_file($userfile['tmp_name'], $dest);
				if ($ERROR!=""){
					echo "<br><b><center>$ERROR</center></b><br>";				
				}
			}
		} else {
			move_uploaded_file($userfile['tmp_name'], $dest);
		}
		if (filesize($dest) > $_SESSION["maxsizeforphotos"]) {
			echo "<b><center>"._PHOTOEXCEEDED." ".$_SESSION["maxsizeforphotos"]." b, (".filesize($dest).")"._PHOTONOTATTACHED."</b></center>";
			unlink($dest);
			$fname = "";
		}
		if ((strpos($userfile['type'],"jpeg")==0) && (strpos($userfile['type'],"png")==0)) {
			echo "<center>"._PHOTOWRONGTYPE.", "._PHOTONOTATTACHED."</center>";
			unlink($dest);
			$fname = "";
		}
	} else {
		$fname = "";
	}
	return $fname;
}

function validateRecipe($recipename,$ingredients,$id){
	GLOBAL $db, $module_name;
			
	if (trim($recipename)=="") {$ERROR=_MUSTNAME;}
	if (trim($ingredients)=="") {$ERROR=_MUSTINGREDIENTS;}
	
	$sql = "select id from ".$_SESSION["recipeprefix"]."_recipes where recipename='$recipename' and id<>$id";
	$result = $db->sql_query($sql);
	$numb_rec = $db->sql_numrows($result);
	if ($numb_rec!=0){$ERROR = _DUBLICATE;} 
		
	if (isset($ERROR)){
		echo "<br><center><B>".$ERROR."</B><br>";
		echo "<b><a href=\"javascript:history.go(-1)\">"._GOBACK."</a></center><br><hr></b><br> ";
		return false;
	} else {
		return true;
	}
}

 
function add($userfile,$recipename,$source,$ingredients,$directions,$serves,$nutrition,$cat_id,$contributer,$preptime,$cooktime,$difficulty,$fname,$introduction,$req_id) {
	Global $db ;

	if (validateRecipe($recipename,$ingredients,0)) {
	    $fname = getFile($userfile);

		if ($contributer=="") {
			$contributer="Guest"; 
		}
		$recipename = trim($recipename);
		
		if (!(get_magic_quotes_gpc())) {
			$recipename = addslashes($recipename);
			$source     = addslashes($source);
			$ingredients = addslashes($ingredients);
			$directions = addslashes($directions);
			$nutrition = addslashes($nutrition);
			$introduction = addslashes($introduction);
			$serves = addslashes($serves);
		}	
		$sql="insert into ".$_SESSION["recipeprefix"]."_recipes (recipename,source,ingredients,directions,serves,nutrition,cat_id,contributer,preptime,cooktime,difficulty,photo,introduction,submittime) values ('$recipename','$source','$ingredients','$directions','$serves','$nutrition',$cat_id,'$contributer','$preptime','$cooktime','$difficulty','$fname','$introduction',now())"; 
		$result = $db->sql_query($sql);
		$id= $db->sql_nextid();
		echo "<center><b>"._THERECIPE." <cite>$recipename</cite> "._HASBEENADDED."</b></center><br>";

		// check for requests
		if (isset($req_id) && ($id>0)){
			requestSubmit($req_id,$id);
		} else {
			$sql = "select req_id from ".$_SESSION["recipeprefix"]."_request where requesttitle='$recipename'";
			$result = $db->sql_query($sql);
			$row = $db->sql_fetchrow($result);
			$numb_rec = $db->sql_numrows($result);
			if ($numb_rec!=0){requestSubmit($row[req_id],$id);}
		}
		return $id;
	}
}


function delete($recipeid) {
	Global $db, $module_name, $admin, $user, $user_name;
	$sql="select photo, contributer, recipename from ".$_SESSION["recipeprefix"]."_recipes where id=$recipeid";
	$result = $db->sql_query($sql);
	$row = $db->sql_fetchrow($result);
	$filepath = "modules/$module_name/photos/$row[photo]";
	if (is_admin($admin)==1 || ($user_name==$row[contributer] && (is_user($user)==1))) {
	    if (($row[photo]!="") && file_exists("$filepath")) {
			unlink ("$filepath");
		};
		$sql="delete from ".$_SESSION["recipeprefix"]."_recipes where id=$recipeid"; 
		$result = $db->sql_query($sql);
		echo "<center><b>"._THERECIPE." <cite>$row[recipename]</cite> "._HASBEENDELETED."</b></center><br>";
	} else {
		echo _NOCONTRIBDELETE;
	};
};


function edit($recipeid) {
	Global $db, $admin, $user, $user_name, $module_name,$offset,$recipename;
	$sql="select * from ".$_SESSION["recipeprefix"]."_recipes where id=$recipeid";
	$result = $db->sql_query($sql);
	$row = $db->sql_fetchrow($result);
	if (is_admin($admin)==1 || ($user_name==$row[contributer] && (is_user($user)==1)) ) {
		echo "<center>"._EDITRECIPEFORM."<br><br><table border=0><tr><td>
		<form method=post enctype=\"multipart/form-data\" action=modules.php?name=$module_name>
		<center><table border=0>
		<tr><td align=right><b>"._RECIPENAME.":</td><td><input type=text name=recipename size=50 value='$row[recipename]'></td></tr>
		<tr><td align=right><b>"._CATEGORY.":</td><td><select name=cat_id>";
		$sql2="select * from ".$_SESSION["recipeprefix"]."_categories order by category";
		$result2 = $db->sql_query($sql2);
		while ($row2 = $db->sql_fetchrow($result2)) {
			if ($row[cat_id]==$row2[id]) {$sel="selected";} else {$sel="";}
			echo "<option value=$row2[id] $sel>$row2[category]";
		}
		echo "</select></td></tr>
		<input type=hidden name=op value=update>
		<input type=hidden name=offset value=$offset>
		<input type=hidden name=recipeid value=$row[id]>
		<input type=hidden name=photo value=$row[photo]>
		<input type=hidden name=contributer value=$row[contributer]>

		<tr><td align=right><b>"._SERVESYIELDS.":</td><td><input type=text name=serves value='$row[serves]'></td></tr>
		<tr><td align=right><b>"._SOURCE.":</td><td><input type=text name=source value='$row[source]'></td></tr>
		<tr><td align=right><b>"._PREPTIME.":</td><td><input type=text name=preptime value='$row[preptime]'></td></tr>
		<tr><td align=right><b>"._COOKTIME.":</td><td><input type=text name=cooktime value='$row[cooktime]'></td></tr>
		<tr><td align=right><b>"._DIFFICULTY.":</td><td><select name=difficulty><option value='$row[difficulty]'>$row[difficulty]
		<option value="._EASY.">"._EASY."<option value="._MODERATE.">"._MODERATE."<option value="._HARD.">"._HARD."<option value="._DIFFICULT.">"._DIFFICULT."
		</select></td></tr></table></center><br>
		<center><b>"._INTRODUCTION."</b><br><textarea name=introduction rows=15 cols=70 wrap=off>$row[introduction]</textarea></center><br><br>
		<center><b>"._INGREDIENTS."</b><br><textarea name=ingredients rows=15 cols=70 wrap=off>$row[ingredients]</textarea></center><br><br>
		<center><b>"._DIRECTIONS."</b><br><textarea name=directions rows=15 cols=70>$row[directions]</textarea></center><br><br>
		<center><b>"._NUTRITIONINFORMATION."</b><br><textarea name=nutrition rows=15 cols=70>$row[nutrition]</textarea><br>";

		if ($_SESSION["maxsizeforphotos"] > 0) {
			echo "<input type=\"hidden\" name=\"MAX_FILE_SIZE\" value=\"".$_SESSION["max_file_size"]."\">
			"._ATTACHTHISPHOTO.": <input name=\"userfile\" type=\"file\" ><br>"._ATTACHTHISPHOTO2." ".$_SESSION["maxsizeforphotos"]." b "._ATTACHTHISPHOTO3."<br>";
			if ($_SESSION["autoresize"]) {
				echo ""._ATTACHPHOTORESIZE."<br>";
			}
			$filepath= "modules/$module_name/photos/$row[photo]";
			if (($row[photo]!="") && file_exists("$filepath")) {
				echo "<img src=\"$filepath\" border=0 width=".$_SESSION["pic_size"].">";
				echo "<input name=deletephoto type=checkbox>"._REMOVECURRENTPHOTO."<br>";
			}
		}
		echo "<input type=submit name=submit value='Update this Recipe'></td></tr></form></table>";
	} else {
		echo _NOCONTRIBEDIT;
	}
}


function update($userfile,$serves,$recipename,$source,$introduction,$ingredients,$directions,$nutrition,$cat_id,$preptime,$cooktime,$difficulty,$photo ,$recipeid) {
	Global $module_name, $db, $deletephoto, $admin, $user;
	
	if (validateRecipe($recipename,$ingredients,$recipeid)) {

	if (is_admin($admin)==1 ||($user_name==$contributer && (is_user($user)==1))) {
		if ($deletephoto == "on") {
			if ($photo != "") {
			    $filepath = "modules/$module_name/photos/$photo" ;
		    	if (file_exists("$filepath")) {
		 			unlink ("$filepath");
					$photo = "";
				};
			};
		};
		if (is_uploaded_file($userfile['tmp_name'])) {
			$fname = getFile($userfile);
			if (($photo != "")&& ($fname !="")) {
				$filepath = "modules/$module_name/photos/$photo";
				if (file_exists("$filepath")) {
					unlink ("$filepath");
				};
			};	
		} else {
			$fname = $photo;
		}

		if (!(get_magic_quotes_gpc())) {
			$recipename = addslashes($recipename);
			$source     = addslashes($source);
			$ingredients = addslashes($ingredients);
			$directions = addslashes($directions);
			$nutrition = addslashes($nutrition);
			$introduction = addslashes($introduction);
			$serves = addslashes($serves);
		}	

		$sql="update ".$_SESSION["recipeprefix"]."_recipes set serves='$serves',recipename='$recipename',source='$source',introduction='$introduction',ingredients='$ingredients',directions='$directions',nutrition='$nutrition',cat_id=$cat_id,preptime='$preptime',cooktime='$cooktime',difficulty='$difficulty',photo='$fname' where id=$recipeid"; 
		$result = $db->sql_query($sql);
		echo "<center><b>"._THERECIPE." <cite>$row[recipename]</cite> "._HASBEENUPDATED."</b></center><br>";
	} else {
		echo _NOCONTRIBEDIT;
	}
	}
}


function addnew($req_id) {
	Global $db, $user_name, $module_name;
	echo "<script language=javascript>
	function ltrim ( s ){
		return s.replace( /^\s*/, '' );
	}

	function rtrim ( s ){
		return s2.replace( /\s*$/, '' );
	}

	function trim ( s ){
		return ltrim(s);
	}
	function chkfields () {
		if ( trim(document.addnew.recipename.value) == '')  {
			alert(\""._MUSTNAME."\");
			return false;};		
		if ( trim(document.addnew.ingredients.value) == '')  {
			alert(\""._MUSTINGREDIENTS."\");
			return false;};
	}
	</script>";
	
	if (isset($req_id)){
		$sqlreq = "select requesttitle,requesttext,cat_id from ".$_SESSION["recipeprefix"]."_request where req_id=$req_id";
		$resultreq = $db->sql_query($sqlreq);
		$row = $db->sql_fetchrow($resultreq);
		$recipename=$row[requesttitle];
		$cat_id=$row[cat_id];
		$introduction=$row[requesttext];
	} else {
		$recipename="";
		$cat_id=0;
		$introduction="";
	}
	echo "<center>"._NEWRECIPEFORM."<br><br>
	<table border=0><tr><td>
	<form name=addnew enctype=\"multipart/form-data\" method=post onSubmit='return chkfields();' action=modules.php?name=$module_name>
	<center>
	<table border=0>
	<tr><td align=right><b>"._RECIPENAME.":</td><td><input type=text name=recipename size=\"50\" value=\"$recipename\"></td></tr>
	<tr><td align=right><b>"._CATEGORY.":</td><td><select name=cat_id>";
	
	$sql="select * from ".$_SESSION["recipeprefix"]."_categories order by category";
	$result = $db->sql_query($sql);
	while ($row = $db->sql_fetchrow($result)) {
		if ($cat_id==$row[id]) {$sel="selected";} else {$sel="";}
		echo "<option value=$row[id] $sel>$row[category]";
	};
	echo "</select></td></tr>
	<input type=hidden name=op value=add>
	<input type=hidden name=contributer value=\"$user_name\">
	<tr><td align=right><b>"._SERVESYIELDS.":</td><td><input type=text name=serves></td></tr>
	<tr><td align=right><b>"._SOURCE.":</td><td><input type=text name=source></td></tr>
	<tr><td align=right><b>"._PREPTIME.":</td><td><input type=text name=preptime></td></tr>
	<tr><td align=right><b>"._COOKTIME.":</td><td><input type=text name=cooktime></td></tr>
	<tr><td align=right><b>"._DIFFICULTY.":</td><td><select name=difficulty>
	<option value="._EASY.">"._EASY."<option value="._MODERATE.">"._MODERATE."<option value="._HARD.">"._HARD."<option value="._DIFFICULT.">"._DIFFICULT."
	</select></td></tr></table></center>
	<br>
	<center><b>"._INTRODUCTION."</b><br><textarea name=introduction rows=15 cols=70 wrap=off>$introduction</textarea></center><br><br>
	<center><b>"._INGREDIENTS."</b><br><textarea name=ingredients rows=15 cols=70 wrap=off></textarea></center><br><br>
	<center><b>"._DIRECTIONS."</b><br><textarea name=directions rows=15 cols=70></textarea></center><br><br>
	<center><b>"._NUTRITIONINFORMATION."</b><br><textarea name=nutrition rows=15 cols=70></textarea><br><br>";

	if ($_SESSION["maxsizeforphotos"] > 0) {
		echo "<input type=\"hidden\" name=\"MAX_FILE_SIZE\" value=\"".$_SESSION["max_file_size"]."\">
		"._ATTACHTHISPHOTO.": <input name=\"userfile\" type=\"file\"><br>"._ATTACHTHISPHOTO2." ".$_SESSION["maxsizeforphotos"]." 
		b "._ATTACHTHISPHOTO3."<br>";
		if ($_SESSION["autoresize"]) {
			echo ""._ATTACHPHOTORESIZE."<br>";
		}
	}
	if (isset($req_id)){
		echo "<input type=\"hidden\" name=req_id value=$req_id>";
	}
	echo "<input type=submit name=submit value='"._SUBMITTHISRECIPE."'></td></tr></form></table>";
}


function emailRecipe($recipeid) {
	Global $module_name, $user_email, $user_name;
	echo "<center><form method=post action=\"modules.php?name=$module_name\">
	<input name=op type=hidden value=sendrecipe>
	<input name=recipeid type=hidden value=$recipeid>";
    echo "<b>"._YOURNAME." </b> <input type=\"text\" name=\"sender_name\" value=\"$user_name\"><br><br>\n"
	."<b>"._YOUREMAIL." </b> <input type=\"text\" name=\"sender_mail\" value=\"$user_email\"><br><br><br>\n"
	."<b>"._FRIENDNAME." </b> <input type=\"text\" name=\"target_name\"><br><br>\n"
	."<b>"._FRIENDEMAIL." </b> <input type=\"text\" name=\"target_mail\"><br><br>\n";
	echo "<input name=submit type=submit value='Send It'></form>";
}


function sendRecipe($recipeid,$sender_name,$sender_mail,$target_name,$target_mail,$req_id) {
	Global $db, $sitename, $nukeurl,$module_name;
	$sql="select * from ".$_SESSION["recipeprefix"]."_recipes where id=$recipeid";
	$result = $db->sql_query($sql);
	$row = $db->sql_fetchrow($result);
	$introduction = urlencode($row[introduction]);
	$introduction = str_replace("%0A","\n",$introduction);
	$introduction = urldecode($introduction);
	$ingredients = urlencode($row[ingredients]);
	$ingredients = str_replace("%0A","\n",$ingredients);
	$ingredients = urldecode($ingredients);
	$directions = urlencode($row[directions]);
	$directions = str_replace("%0A","\n",$directions);
	$directions = urldecode($directions);
	$nutrition = urlencode($row[nutrition]);
	$nutrition = str_replace("%0A","\n",$nutrition);
	$nutrition = urldecode($nutrition);
	$source = str_replace("<br>","\n",$row[source]);
	$submittime = $row[submittime];
	$submittime_format = strftime(""._DATEFORMAT."",strtotime($row[submttime]));

	if ($req_id>0){
		$sql2 = "select req_id,requesttitle,check_num from ".$_SESSION["recipeprefix"]."_request where req_id=$req_id";
		$result2 = $db->sql_query($sql2);
		$row2 = $db->sql_fetchrow($result2);
		$body=""._UREQUESTED." "._ONR." $sitename :\n ".$row2[requesttitle]."<br>\n";
		$body.="<a href=\"$nukeurl"."/modules.php?name=".$module_name."&amp;file=request&amp;op=requestopen&amp;req_id=$req_id\">".$row2[requesttitle]."</a><br>\n";
		$check_num=$row2[check_num];
		$finishlink = "$nukeurl/modules.php?name=$module_name&file=request&op=approve&req_id=$req_id&recipeid=$recipeid&check_num=$check_num";
		$finishlink2 = "$nukeurl/modules.php?name=$module_name&file=request&op=disapprove&req_id=$req_id&recipeid=$recipeid&check_num=$check_num";
		$body .= ""._REQUESTAPPROVE."<a href=\"".$finishlink."\">"._REQUESTAPPROVELINK."</a><br>\n";
		$body .= ""._REQUESTDISAPPROVE."<a href=\"".$finishlink2."\">"._REQUESTDISAPPROVELINK."</a><br>\n";
	} else {
		$body=""._AUSER." ($sender_name) "._ONR." $sitename "._REQUESTEDSEND."\n\n";
	}
	$body .="<center><h2> $row[recipename]</center></h2>\n
	"._SERVESYIELDS.": $row[serves]\n
	"._CATEGORY.": ".getCategory($row[cat_id])."\n
	"._PREPTIME.": $row[preptime]\n
	"._COOKTIME.": $row[cooktime]\n
	"._DIFFICULTY.": $row[difficulty]\n\n";

	if ($row[introduction] != "") {
		$body .="<center><h4>"._INTRODUCTIONINFORMATION.":</center></h4>\n$introduction\n\n";
	};
	$body .="<center><h4>"._INGREDIENTS.":</center></h4>\n
	$ingredients\n\n
	<center><h4>"._DIRECTIONS.":</center></h4>\n
	$directions\n\n";

	if ($row[nutrition] != "") {
		$body .="<center><h4>"._NUTRITIONINFORMATION.":</center></h4>\n$nutrition\n\n";
	};

	$body .="<br><br>"._SOURCE.": $source\n<br>
	"._CONTRIBUTEDBY.": $row[contributer] "._ONR." $submittime_format\n\n<br>";
	$body .= "<center>"._THISREP." ".$sitename."\n<br>";
	$body .= "<A href=\"$nukeurl\">$nukeurl</a>\n<br>";
	$body .= _URL."<A href=\"$nukeurl"."/modules.php?name=".$module_name."&amp;op=viewrecipe&amp;recipeid=".$recipeid."\">$nukeurl"."/modules.php?name=".$module_name."&amp;op=viewrecipe&amp;recipeid=".$recipeid."</a>\n";

	$subject = _ARECIPE." from $sitename";
	$headers  = "MIME-Version: 1.0\r\n";
	$headers .= "Content-type: text/html; charset=iso-8859-1\r\n";

	$headers .= "From: \"$sender_name\" <$sender_mail>\nX-Mailer: PHP/" . phpversion();
	mail($target_mail,$subject,$body,$headers); 
	if ($req_id>0) {
	// add accept or reject
	} else {
		echo "<center>"._RECIPESENT."</center>";
	}	
}


function viewRecipe($recipeid){
	Global $module_name, $db, $user, $admin, $user_name, $user_email, $locale, $offset, $numrecip, $qdb, $qdborder, $title, $mode, $order, $thold ;
	if (isset($offset)){
		$_SESSION["oldoffset"]=$offset;
	} 
	if (isset($recipeid) || $recipeid=0) {
		$sql="select * from ".$_SESSION["recipeprefix"]."_recipes where id=$recipeid";
	} else {
		$qdb = $_SESSION["qdb"];
		$qdborder = $_SESSION["qdborder"];
		$sql = "select R.* ,S.score/S.number_votes as rate from ".$_SESSION["recipeprefix"]."_recipes R LEFT JOIN ".$_SESSION["recipeprefix"]."_score S ON(R.id=S.id) $qdb $qdborder limit $offset, 1";
		
	}
	$numrecip = $_SESSION["numrecip"];
	$result = $db->sql_query($sql);
	$row = $db->sql_fetchrow($result);
	$introduction = urlencode($row[introduction]);
	$introduction = str_replace("%0A","<br>",$introduction);
	$introduction = urldecode($introduction);
	$ingredients = urlencode($row[ingredients]);
	$ingredients = str_replace("%0A","<br>",$ingredients);
	$ingredients = urldecode($ingredients);
	$directions = urlencode($row[directions]);
	$directions = str_replace("%0A","<br>",$directions);
	$directions = urldecode($directions);
	$nutrition = urlencode($row[nutrition]);
	$nutrition = str_replace("%0A","<br>",$nutrition);
	$nutrition = urldecode($nutrition);
	$submittime = $row[submittime];
	setlocale(LC_TIME, $locale);
	$submittime_format = strftime(""._DATEFORMAT."",strtotime($row[submittime]));
	$page = ceil(($offset+1)/$_SESSION["recipnum"]);
	$offsetprev = $offset-1;
	$offsetnext = $offset+1;
	$leftarrow = "images/left.gif";
	$rightarrow = "images/right.gif";
	$recipeid = $row[id];
	$sqlr = "select score, number_votes from ".$_SESSION["recipeprefix"]."_score where id=$recipeid";
	$resultr = $db->sql_query($sqlr);
	$rowr = $db->sql_fetchrow($resultr);
	$number_votes = $rowr[number_votes];
	$score = $rowr[score];
	if ($number_votes != 0) {
	    $rate = substr($score / $number_votes, 0, 4);
    	$r_image = round($rate);
    	$the_image = "<img src=\"modules/$module_name/images/stars-$r_image.gif\" border=\"1\">";
	} else {
    	$rate = 0;
    	$the_image = "";
	}

	
	echo "<table border=\"0\" width=\"100%\"><tr>";
	if ($offsetprev>=0) {
		echo "<td align=\"left\" width=\"33%\"><a href=\"modules.php?name=$module_name&amp;op=viewrecipe&amp;offset=$offsetprev\"><img src=\"$leftarrow\" border=\"0\" hspace=\"10\">"._PREV."</a></td>";}
	else {
		echo "<td align=\"left\" width=\"33%\"></td>";
	}
	
	if (isset($offset)){
		echo "<td align=\"center\"  width=\"34%\"><a href=\"modules.php?name=$module_name&amp;op=newpage&amp;pagenum=$page\">"._LIST."</a></td>";
	
		if ($offsetnext<$numrecip) {
			echo "<td align=\"right\" width=\"33%\"><a href=\"modules.php?name=$module_name&amp;op=viewrecipe&amp;offset=$offsetnext\">"._NEXT."<img src=\"$rightarrow\" border=\"0\" hspace=\"10\"></a></td>";}
		else {
			echo "<td align=\"right\" width=\"33%\"></td>";
		}
	} else {
		echo "<td align=\"center\"  width=\"34%\">"._GOBACK."</td>";
		echo "<td align=\"right\" width=\"33%\"></td>";
	}
		
	echo "</tr></table>";

	echo "<center><font class=\"option\">";
	if ($_SESSION["option_icon"]) {
		$print_icon = "<img src=\"modules/$module_name/images/print.gif\" border=\"0\" alt=\""._PRINTERFRIENDLY."\" title=\""._PRINTERFRIENDLY."\">";
		$friend_icon ="<img src=\"modules/$module_name/images/friend.gif\" border=\"0\" alt=\""._EMAILRECIPE."\" title=\""._EMAILRECIPE."\">";
		$edit_icon ="<img src=\"modules/$module_name/images/edit.gif\" border=\"0\" alt=\""._EDITRECIPE."\" title=\""._EDITRECIPE."\">";
		$delete_icon ="<img src=\"modules/$module_name/images/delete.gif\" border=\"0\" alt=\""._DELETERECIPE."\" title=\""._DELETERECIPE."\">";
	} else {
		$print_icon = "";
		$friend_icon ="";
		$edit_icon ="";
		$delete_icon ="";
	}
	if (!($_SESSION["option_icon"]) | ($_SESSION["option_text"]) ) {
		$print_text = " "._PRINTERFRIENDLY;
		$friend_text = " "._EMAILRECIPE;
		$edit_text = " "._EDITRECIPE;
		$delete_text = " "._DELETERECIPE;
	} else {
		$print_text = "";
		$friend_text ="";
		$edit_text ="";
		$delete_text ="";
	}
	echo "<a href=\"modules.php?name=$module_name&amp;file=print&amp;recipeid=$row[id]\" target='_new'>$print_icon$print_text</a>";
	echo " | <a href=\"modules.php?name=$module_name&amp;op=emailrecipe&amp;recipeid=$row[id]\">$friend_icon$friend_text</a></font>";
	if (($user_name==$row[contributer] && (is_user($user)==1)) || is_admin($admin)==1) {
		echo "
		<script language=javascript>
		function concure () {
			if (confirm(\""._AREYOUSURE1."\"))
				if (confirm(\""._AREYOUSURE2."\"))
					return true
				else
					return false
			else
				return false
			}
		</script>
		<font class=\"option\">
		| <a href=\"modules.php?name=$module_name&amp;op=edit&amp;recipeid=$row[id]&amp;offset=$offset\">$edit_icon$edit_text</a> | 
		<a href=\"modules.php?name=$module_name&amp;op=delete&amp;recipeid=$row[id]\" onClick='return concure();'>$delete_icon$delete_text</a>
		</font></center>";
	}
	echo "<hr>";
	echo "<table border=0 width=100%><center><th colspan=\"2\">$row[recipename] $the_image</th></center>";
    echo "<tr>"; 
	echo "<font class=\"content\">
	<tr><td valign=top align=left class=\"row1\" width=\"60%\">
	"._SERVESYIELDS.": <cite>$row[serves]</cite><br>
	"._PREPTIME.": <cite>$row[preptime]</cite><br>
	"._COOKTIME.": <cite>$row[cooktime]</cite><br>
	"._CATEGORY.": <cite>".getCategory($row[cat_id])."</cite><br>
	"._DIFFICULTY.": <cite>$row[difficulty]</cite><br>
	</td><td valign=top align=center class=\"row1\" width=\"40%\">";
	if ($row[photo] > "" && file_exists("modules/$module_name/photos/$row[photo]")) {
		echo "<img src=\"modules/$module_name/photos/$row[photo]\" border=0 width=".$_SESSION["pic_size"].">";
	};
	echo "</td></tr></font></tr>";
	if ($row[introduction] != "") {
		echo "<tr><td class=\"cat\" colspan =\"2\"><center><strong>"._INTRODUCTION."</strong></center></td></tr>";
		echo "<tr><td class=\"row1\" colspan =\"2\">$introduction</td></tr>";
	}
	echo "<tr><td class=\"cat\" colspan =\"2\"><center><strong>"._INGREDIENTS."</strong></center></td></tr>";
	echo "<tr><td class=\"row1\" colspan =\"2\">$ingredients</td></tr>";
	echo "<tr><td class=\"cat\" colspan =\"2\"><center><strong>"._DIRECTIONS."</strong></center></td></tr>";
	echo "<tr><td class=\"row1\" colspan =\"2\">$directions</td></tr>";
	if ($row[nutrition] != "") {
		echo "<tr><td class=\"cat\" colspan =\"2\"><center><strong>"._NUTRITIONINFORMATION."</strong></center></td></tr>";
		echo "<tr><td class=\"row1\" colspan =\"2\">$nutrition</td></tr>";
	};
	echo "<tr><td class=\"genmed\" colspan =\"2\"><center>"._SOURCE.": ".make_clickable($row[source])."</center></td></tr>";
	echo "<tr><td class=\"genmed\" colspan =\"2\"><center>"._CONTRIBUTEDBY.":<a href=\"modules.php?name=Your_Account&amp;op=userinfo&amp;username=$row[contributer]\">$row[contributer]</a> "._ONR." $submittime_format</center></td></tr>";

	echo "</table>";
	echo "<center><font class=\"option\"><a href=\"modules.php?name=$module_name&amp;op=contributerbrowse&amp;query=$row[contributer]\">"._MOREBY."$row[contributer]</a><br></font></center>";
	
	CloseTable();
	OpenTable();
	$id = $row[id];
	include("modules/$module_name/rateform.php");
	
	echo "<table border=\"0\" width=\"100%\">";
	echo $ratecontent;
	echo "</table>";
	if ($_SESSION["allowcomment"]) {
		CloseTable();
		OpenTable();
		echo "<table border=\"0\" width=\"100%\">";
		echo "<tr><td class=\"cat\" ><center><strong>"._COMMENT."</strong></tr>";
		//	echo "<tr><td class=\"row2\">"._COMMINGSOON."</td></tr>";
		$title=$row[recipename];
		$subject = $row[recipename];
		echo "<tr><td  >";
		include("modules/$module_name/comments.php");
		echo "</td></tr></table>";
	}
	// update counter
	if (is_admin($admin)!=1) {
		$readtbl = $_SESSION["readtbl"];
		// only count one read per session
		if (!(isset($readtbl[$recipeid]))) {
			$sql="update ".$_SESSION["recipeprefix"]."_recipes set counter = counter+1 where id=$recipeid";
			$result = $db->sql_query($sql);
			$readtbl[$recipeid] = true;
			$_SESSION["readtbl"] = $readtbl;
		}
	}

};



function makeSearchQuery($sort,$sort_dir,$searchtext,$searchsubmitter,$cat_id,$chall,$chname,$chintroduction,$chingredients,$chdirections,$chnutrition,$chphoto){
	Global $qdb, $query, $orderby;
	$orderby = " order by $sort $sort_dir ";
	
	$query = "";
	$AND = "";
	if ($cat_id != -1) {
		$query .= $AND." cat_id = $cat_id ";
		$AND = " AND ";
	}
	if ($chphoto == "X") {
		$query .= $AND." photo > '' ";
		$AND = " AND ";
	}
	if ($searchsubmitter!="") {
		$query .= $AND." contributer like '%%$searchsubmitter%%' ";
		$AND = " AND ";
	}
	if (($searchtext!="") && ($chall=="X" || $chintroduction=="X" || $chname=="X" || $chdirections=="X" || $chingredients=="X" || $chnutrition=="X")) {
		$query .= $AND." (";
		$OR = "";
		if ($chall=="X" || $chname=="X") {
			$query .= $OR." recipename like '%%$searchtext%%' ";
			$OR = " OR ";
		}
		if ($chall=="X" || $chintroduction=="X") {
			$query .= $OR." introduction like '%%$searchtext%%' ";
			$OR = " OR ";
		}
		if ($chall=="X" || $chingredients =="X") {
			$query .= $OR." ingredients like '%%$searchtext%%' ";
			$OR = " OR ";
		}
		if ($chall=="X" || $chdirections =="X") {
			$query .= $OR." directions like '%%$searchtext%%' ";
			$OR = " OR ";
		}
		if ($chall=="X" || $chnutrition =="X") {
			$query .= $OR." nutrition like '%%$searchtext%%' ";
			$OR = " OR ";
		}	
		$query .= ")";
	}
	$qdb = $query;
	if ($query!="") {$qdb = "where $qdb";}
}

function getLatest(){
	GLOBAL $db, $qdb, $qdborder;
	$sql = "select id from ".$_SESSION["recipeprefix"]."_recipes order by id DESC limit 0,1";
	$result = $db->sql_query($sql);
	$row = $db->sql_fetchrow($result);
	$qdb = "";
	$qdborder = "order by id DESC";
	return $row[id];
}

function introduction(){
	GLOBAL $db, $module_name, $prefix;
	$sql = "SELECT * FROM ".$prefix."_modules_introduction where module='$module_name'";
	$result = $db->sql_query($sql);
	$row = $db->sql_fetchrow($result);
	echo "".$row[intro]."";
}

function requestSubmit($req_id,$id){
	GLOBAL $db,$adminmail,$sitename;
	$sql = "select requesttitle,emailresponse,requestmail,requestname from ".$_SESSION["recipeprefix"]."_request where req_id=$req_id";
	$result = $db->sql_query($sql);
	$row = $db->sql_fetchrow($result);
	if ($row[requestname]=="" || $row[requestname]=="Anonymous") {
		$status = 3;
	} else {
		$status = 1;
	}
	if (($row[emailresponse]=="X") && ($row[requestmail]!="")) {
		sendRecipe($id,$sitename,$adminmail,$row[requestname],$row[requestmail],$req_id);
	}
	$sql = "insert into ".$_SESSION["recipeprefix"]."_request_recipe (req_id, id,status) values($req_id,$id,$status)";
	$result = $db->sql_query($sql);
	$sql = "update ".$_SESSION["recipeprefix"]."_request set status=$status where req_id=$req_id ";
	$result = $db->sql_query($sql);
}

//********  MAIN CONTROL PLACED HERE **********


if (is_writeable("modules/$module_name/photos") != 1) {$_SESSION["maxsizeforphotos"]=0;};

if (is_admin($admin)==1){
	cookiedecode($admin);
	$user_name = $cookie[0];
	$user_email = $adminmail;
} else {
	if (is_user($user)){
		cookiedecode($user);
		$user_name = $cookie[1];
		$uid = $cookie[0];
		$sql="select user_email from ${user_prefix}_users where user_id =$uid";
		$result=$db->sql_query($sql);
		$row = $db->sql_fetchrow($result);
		$user_email = $row[user_email];
	} else {
		$user_name = "Anonymous"; 
	}
}
$recipe_source_version = "1.5.4";
if ($op=="addnew"){
	session_cache_limiter('private');
}
session_start();
include ('header.php');

if (!(isset($_SESSION["recipe_version"]))){
	getConfig();
}
if (issetup() == '') {
	OpenTable();
	echo "<center><b><font class=\"title\">"._RECIPES."</font></b>";
	echo "<p><b>Setting up database tables.</b></p>";
	include("modules/$module_name/installer/install.php");
	echo "<p>Done.. Run this module again..</p></center>";
	CloseTable();
	session_destroy();	
	session_cache_limiter('nocache');
	session_start();
	include ('footer.php');
	exit;
};

include("modules/$module_name/header.php");

switch($op){
    default:
		recipe_header();
		switch($_SESSION["startpage"]){
			default: break;
			case "nothing": break;
			case "searchstart": searchStart(); break;		
			case "all": 
				$qdb = "";
				list_recipes($qdb," order by recipename,submittime ",$_SESSION["recipnum"]); 
				break;
			case "introduction": introduction(); break;
			case "latest": viewRecipe(getLatest()); break;
			case "submit": addnew(); break;
			case "request": include_once "modules/$module_name/request_list.php.inc"; break;

		}
		break;
	case "viewrecipe":
		//$qdb = htmlspecialchars($qdb,ENT_NOQUOTES);
		$qdborder = htmlspecialchars($qdborder,ENT_NOQUOTES);
		if (get_magic_quotes_gpc()) {
			$qdb = stripslashes($qdb);
			$qdborder = stripslashes($qdborder);
		}
		recipe_header();	
		viewRecipe($recipeid);
		break;
	case "sendrecipe": 
		sendRecipe($recipeid,$sender_name,$sender_mail,$target_name,$target_mail,$req_id); 
		recipe_header();
		viewrecipe($recipeid);
		break;
	case "emailrecipe":
		recipe_header();
		emailRecipe($recipeid);
		break;
	case "addnew":
		recipe_header();
		addNew($req_id);
		break;
	case "update": 
		$userfile= $HTTP_POST_FILES['userfile'];
		recipe_header();
		update($userfile,$serves,$recipename,$source,$introduction,$ingredients,$directions,$nutrition,$cat_id,$preptime,$cooktime,$difficulty,$photo, $recipeid);
		viewRecipe($recipeid);
		break;
	case "edit":
		recipe_header();
		edit($recipeid);
		break;
	case "delete":
		recipe_header();
		delete($recipeid);
		break;
	case "add":
		$userfile= $HTTP_POST_FILES['userfile'];	
		recipe_header();	
		$id=add($userfile,$recipename,$source,$ingredients,$directions,$serves,$nutrition,$cat_id,$contributer,$preptime,$cooktime,$difficulty,$fname,$introduction,$req_id); 
		break;
	case "searchstart":
		recipe_header();
		searchStart();
		break;		
	case "alphabrowse":
		$qdb = "where recipename like '$query%%'";
		recipe_header();
		list_recipes($qdb," order by recipename,submittime ",$_SESSION["recipnum"]); 
		break;
	case "contributerbrowse": 
		$qdb = "where contributer = '$query'"; 
		recipe_header();
		list_recipes($qdb," order by recipename,submittime ",$_SESSION["recipnum"]); 
		break;
	case "newpage": 
		//$qdb = htmlspecialchars($qdb,ENT_NOQUOTES);
		$qdborder = htmlspecialchars($qdborder,ENT_NOQUOTES);
		if (get_magic_quotes_gpc()) {
			$qdb = stripslashes($qdb);
			$qdborder = stripslashes($qdborder);
		}
		recipe_header();
		list_recipes($qdb,$qdborder,$_SESSION["recipnum"]); 
		break;
	case "search": 
		makeSearchQuery($sort,$sort_dir,$searchtext,$searchsubmitter,$cat_id,$chall,$chname,$chintroduction,$chingredients,$chdirections,$chnutrition,$chphoto);
		recipe_header();
		list_recipes($qdb,$orderby,$_SESSION["recipnum"]);
		break;
	case "mostread":
		recipe_header();
		list_recipes(''," order by counter desc ",10);
		break;
	case "toprated":
		recipe_header();
		list_recipes(''," order by rate desc, counter desc ",10);
		break;
	case "rate": include("modules/$module_name/rate.php");
		recipe_header();
		vote($score,$id);
		viewrecipe($id);
		break;
	case "return": 
		$offset = $_SESSION["oldoffset"];
		recipe_header();
		viewrecipe($notset);
		break;
		
}	

if (($op!="") || ($_SESSION["startpage"]!="nothing") ){
	CloseTable();
}
// DO NOT REMOVE THE FOLOWING LINES, IT WLL BE A VIOLATION TO GNU/GPL and Copyright rules
echo "<center><tiny>Recipe Module by Jens <A href=\"http://visayas.dk\">http://visayas.dk</A>&copy</tiny></center>";
include ('footer.php');
?>