# MySQL-Front Dump 2.5
#
# Host: localhost   Database: visayas65b
# --------------------------------------------------------
# Server version 3.23.53-max-nt
#
# NB NB NB 
# Change 'nuke' to the prefix you use at your site
# change 'recipes' to the prefix you use at your recipe module
# change 'Recipes' in columns named module to the name of your module if different

#
# Table structure for table 'recipes_categories'
#

CREATE TABLE recipes_categories (
  id int(10) NOT NULL auto_increment,
  category varchar(100) default NULL,
  icon varchar(255) NOT NULL default '',
  PRIMARY KEY  (id)
) TYPE=MyISAM;



#
# Dumping data for table 'recipes_categories'
#

INSERT INTO recipes_categories (id, category, icon) VALUES("1", "Appetizers", "appetizers.jpg");
INSERT INTO recipes_categories (id, category, icon) VALUES("2", "Breads", "bread_2.gif");
INSERT INTO recipes_categories (id, category, icon) VALUES("3", "Desserts", "dessert_2.jpg");
INSERT INTO recipes_categories (id, category, icon) VALUES("4", "Salads", "salad.jpg");
INSERT INTO recipes_categories (id, category, icon) VALUES("5", "Soups", "soup_2.gif");
INSERT INTO recipes_categories (id, category, icon) VALUES("7", "Poultry", "poultry.gif");
INSERT INTO recipes_categories (id, category, icon) VALUES("8", "Pork", "pork.jpg");
INSERT INTO recipes_categories (id, category, icon) VALUES("9", "Beef", "beef.jpg");
INSERT INTO recipes_categories (id, category, icon) VALUES("10", "Seafood", "seafood.jpg");
INSERT INTO recipes_categories (id, category, icon) VALUES("11", "SideDishes", "sidedish.jpg");
INSERT INTO recipes_categories (id, category, icon) VALUES("12", "Vegetables", "vegetables_2.gif");
INSERT INTO recipes_categories (id, category, icon) VALUES("13", "Fruits", "fruits.jpg");
INSERT INTO recipes_categories (id, category, icon) VALUES("14", "Pasta", "pasta.gif");
INSERT INTO recipes_categories (id, category, icon) VALUES("15", "Breakfast", "breakfast.jpg");
INSERT INTO recipes_categories (id, category, icon) VALUES("16", "Sauces", "sauces.jpg");

#
# Table structure for table 'recipes_recipes'
#

CREATE TABLE recipes_recipes (
  id int(10) NOT NULL auto_increment,
  recipename varchar(255) default NULL,
  source varchar(255) default NULL,
  ingredients text,
  directions text,
  nutrition text,
  serves varchar(100) default NULL,
  preptime varchar(100) default NULL,
  cooktime varchar(100) default NULL,
  difficulty varchar(100) default NULL,
  contributer varchar(255) default NULL,
  photo varchar(255) default NULL,
  submittime datetime default NULL,
  introduction text,
  counter mediumint(8) unsigned NOT NULL default '0',
  cat_id int(10) unsigned NOT NULL default '0',
  PRIMARY KEY  (id)
) TYPE=MyISAM;



#
# Table structure for table 'recipes_score'
#

CREATE TABLE recipes_score (
  id int(10) NOT NULL default '0',
  score mediumint(8) NOT NULL default '0',
  number_votes mediumint(8) NOT NULL default '0',
  PRIMARY KEY  (id)
) TYPE=MyISAM;




#
# Table structure for table 'recipes_voters'
#

CREATE TABLE recipes_voters (
  id int(10) NOT NULL default '0',
  user_md5_id varchar(32) NOT NULL default '',
  time int(11) NOT NULL default '0',
  PRIMARY KEY  (id,user_md5_id)
) TYPE=MyISAM;




#
# Table structure for table 'nuke_modules_comments'
#

CREATE TABLE nuke_modules_comments (
  tid int(11) NOT NULL auto_increment,
  pid int(11) NOT NULL default '0',
  id int(11) NOT NULL default '0',
  date datetime default NULL,
  name varchar(60) NOT NULL default '',
  email varchar(60) default NULL,
  url varchar(60) default NULL,
  host_name varchar(60) default NULL,
  subject varchar(85) NOT NULL default '',
  comment text NOT NULL,
  score tinyint(4) NOT NULL default '0',
  reason tinyint(4) NOT NULL default '0',
  module varchar(255) NOT NULL default '',
  PRIMARY KEY  (tid),
  KEY tid (tid),
  KEY pid (pid),
  KEY sid (id)
) TYPE=MyISAM;



#
# Table structure for table 'nuke_modules_config'
#

CREATE TABLE nuke_modules_config (
  name varchar(40) NOT NULL default '0',
  value varchar(255) NOT NULL default '',
  type varchar(10) NOT NULL default '',
  module varchar(255) NOT NULL default '',
  explaintext text NOT NULL,
  domain text NOT NULL,
  PRIMARY KEY  (name,module)
) TYPE=MyISAM;



#
# Dumping data for table 'nuke_modules_config'
#

INSERT INTO nuke_modules_config (name, value, type, module, explaintext, domain) VALUES("maxsizeforphotos", "25000", "CHAR", "Recipes", "The maximun size of a picture stored. Size given in bytes", "");
INSERT INTO nuke_modules_config (name, value, type, module, explaintext, domain) VALUES("autoresize", "true", "BOOL", "Recipes", "If set, the module will attempt to resize the picture. Also see the variable \'fittype\'", "");
INSERT INTO nuke_modules_config (name, value, type, module, explaintext, domain) VALUES("recipe_version", "1.5.2", "CHAR", "Recipes", "Do not update. This is used to check for updates", "");
INSERT INTO nuke_modules_config (name, value, type, module, explaintext, domain) VALUES("fittype", "file_size", "CHAR", "Recipes", "\'\'either choose pic_size or file_size.<BR>If pic_size is choosen the fit will be using the variable pic_sive, otherwise the maxsizeforphotos is used. In both cases the largest possible picture is stored\'", "pic_size,file_size");
INSERT INTO nuke_modules_config (name, value, type, module, explaintext, domain) VALUES("pic_size", "200", "INT", "Recipes", "Sets the maximum width of a picture in pixels", "");
INSERT INTO nuke_modules_config (name, value, type, module, explaintext, domain) VALUES("method", "im", "CHAR", "Recipes", "The 3 methods \'gd1\' \'gd2\' and imagemagic (im) is supported. Check your set-up for the appropiate setting.<br>\r\nIf using \'im\' also fill in the impath and im_options ", "gd1,gd2,im");
INSERT INTO nuke_modules_config (name, value, type, module, explaintext, domain) VALUES("impath", "", "CHAR", "Recipes", "Path to where ImageMagic is installed", "");
INSERT INTO nuke_modules_config (name, value, type, module, explaintext, domain) VALUES("im_options", "", "CHAR", "Recipes", "Imagemagic options. See documentation about ImageMagic", "");
INSERT INTO nuke_modules_config (name, value, type, module, explaintext, domain) VALUES("jpeg_qual", "80", "INT", "Recipes", "Quality of resized picture. range 1-100", "");
INSERT INTO nuke_modules_config (name, value, type, module, explaintext, domain) VALUES("default_file_mode", "0644", "CHAR", "Recipes", "New pictures are stored with this chmod value", "");
INSERT INTO nuke_modules_config (name, value, type, module, explaintext, domain) VALUES("recipnum", "10", "INT", "Recipes", "Number of recipes in the list on one page", "");
INSERT INTO nuke_modules_config (name, value, type, module, explaintext, domain) VALUES("limitpn", "500", "CHAR", "Recipes", "Highest number of recipes that can be listed in the \'All\' situation", "");
INSERT INTO nuke_modules_config (name, value, type, module, explaintext, domain) VALUES("allowcomment", "true", "BOOL", "Recipes", "If set comments will be included", " ");
INSERT INTO nuke_modules_config (name, value, type, module, explaintext, domain) VALUES("ratewait", "30", "INT", "Recipes", "The number of days a rater have to wait before he can rate the same recipe again", "");
INSERT INTO nuke_modules_config (name, value, type, module, explaintext, domain) VALUES("max_file_size", "1000000", "CHAR", "Recipes", "The largest possible picture that the browser will accept to upload. ", "");
INSERT INTO nuke_modules_config (name, value, type, module, explaintext, domain) VALUES("quick_search_name", "false", "BOOL", "Recipes", "If set there will be a namefield and search button in the header", "");
INSERT INTO nuke_modules_config (name, value, type, module, explaintext, domain) VALUES("quick_search_cat", "false", "BOOL", "Recipes", "If set the header will contain a quicksearch for categories", "");
INSERT INTO nuke_modules_config (name, value, type, module, explaintext, domain) VALUES("icon_file", "modules/Recipes/icons", "CHAR", "Recipes", "path to the folder containing icon used for categories", "");
INSERT INTO nuke_modules_config (name, value, type, module, explaintext, domain) VALUES("startpage", "introduction", "CHAR", "Recipes", "This will be shown below the header when opening the module", "nothing,all,introduction,latest,searchstart,submit");
INSERT INTO nuke_modules_config (name, value, type, module, explaintext, domain) VALUES("quick_search_cat_icon", "true", "BOOL", "Recipes", "If set there will be thombnail to the categories", "");
INSERT INTO nuke_modules_config (name, value, type, module, explaintext, domain) VALUES("module_developer", "false", "BOOL", "Recipes", "If set the administrator get access to update and create new settings that can only be used if programs are changed at the same time", "");
INSERT INTO nuke_modules_config (name, value, type, module, explaintext, domain) VALUES("alphabrowse", "true", "BOOL", "Recipes", "if set the header will include shortcuts to list of recipes starting with a given letter", "");
INSERT INTO nuke_modules_config (name, value, type, module, explaintext, domain) VALUES("recipeprefix", "recipes", "CHAR", "Recipes", "This is used to make it possible having more than one recipe module running in the same database without using the same tables", "");
INSERT INTO nuke_modules_config (name, value, type, module, explaintext, domain) VALUES("quick_search_icon_width", "40", "INT", "Recipes", "This is the size of the icons in the category quicksearch block", "");


#
# Table structure for table 'nuke_modules_introduction'
#

CREATE TABLE nuke_modules_introduction (
  intro text,
  module varchar(255) NOT NULL default '',
  PRIMARY KEY  (module)
) TYPE=MyISAM;


